define("app/js/subway/common", function(){

	window.dataServerPath = "http://m.amap.com/subway/";

	var SW = {
		cache: {
			curCity: {
				adcode: null,
				name: null
			},
			dataForDrw: {},
			cities: {},
			lines: {},
			stations: {},
			stationsInfo: {},
			stationspoi: {},
			offset: {}
		},
		datas: [],
		info_datas: [],
		// 从adcode前四位读取文件名称
		fileNameData: {
			'1100': 'beijing',
			'3100': 'shanghai',
			'4401': 'guangzhou',
			'4403': 'shenzhen',
			'4201': 'wuhan',
			'1200': 'tianjin',
			'3201': 'nanjing',
			'8100': 'xianggang',
			'5000': 'chongqing',
			'3301': 'hangzhou',
			'2101': 'shenyang',
			'2102': 'dalian',
			'5101': 'chengdu',
			'2201': 'changchun',
			'3205': 'suzhou',
			'4406': 'foshan',
			'5301': 'kunming',
			'6101': 'xian',
			'4101': 'zhengzhou',
			'2301': 'haerbin',
			'4301': 'changsha',
			'3302': 'ningbo',
			'3202': 'wuxi',
			'3702': 'qingdao',
            '3601': 'nanchang'
		},
		cityname:{
			'1100': '\u5317\u4eac',//北京,
			'3100': '\u4e0a\u6d77',//上海,
			'4401': '\u5e7f\u5dde',//广州,
			'4403': '\u6df1\u5733',//深圳,
			'4201': '\u6b66\u6c49',//武汉,
			'1200': '\u5929\u6d25',//天津,
			'3201': '\u5357\u4eac',//南京,
			'8100': '\u9999\u6e2f',//香港,
			'5000': '\u91cd\u5e86',//重庆,
			'3301': '\u676d\u5dde',//杭州,
			'2101': '\u6c88\u9633',//沈阳,
			'2102': '\u5927\u8fde',//大连,
			'5101': '\u6210\u90fd',//成都,
			'2201': '\u957f\u6625',//长春,
			'3205': '\u82cf\u5dde',//苏州,
			'4406': '\u4f5b\u5c71',//佛山,
			'5301': '\u6606\u660e',//昆明,
			'6101': '\u897f\u5b89',//西安,
			'4101': '\u90d1\u5dde',//郑州,
			'2301': '\u54c8\u5c14\u6ee8',//哈尔滨,
			'4301': '\u957f\u6c99',//长沙
			'3302': '\u5b81\u6ce2',//宁波
			'3202': '\u65e0\u9521',//无锡
			'3702': '\u9752\u5c9b',//青岛
            '3601': '\u5357\u660c' //南昌
		},
		sm: ['SM-G9200','SM-G9208','SM-G9209','SM-G920A','SM-G920F','SM-G920FQ','SM-G920I','SM-G920K','SM-G920L','SM-G920P','SM-G920R4','SM-G920S','SM-G920T','SM-G920V','SM-G920W8','SC-05G','SM-G9250','SM-G925A','SM-G925F','SM-G925FQ','SM-G925I','SM-G925K','SM-G925L','SM-G925P','SM-G925R4','SM-G925S','SM-G925T','SM-G925V','SM-G925W8','SC-04G','SM-G9280','SM-G928A','SM-G928V','SM-G928F','SM-G928S','G9287','G928I','SM-G928K','G928L','SM-G928P','SM-G928R4','SM-G928W8'],
    	tip_bottom: 'tip_show',
		swInit: function() {
			var self = this;
			FastClick.attach(document.body);
			amapCache.init({
				complete: function() {
					self.initCity(); //根据缓存加载相应城市
					tip.init();
				},
				versionPath : dataServerPath + "data/version/version.json"
			});

			// window.onhashchange = function(){
			// 	location.reload();
			// }
		},
		initCity: function() {
			var self = this;
			self.changeCity();
			// 通过监听hashchange来更改城市
			$(window).on('hashchange', function() {
				location.reload();//
				//self.changeCity();
			});
		},
		changeCity: function() {
			var self = this;
			var param;
			var os = navigator.userAgent;

			if(os.match(/iphone|ipad|ipod/i)){
				var hash = window.location.hash.replace(/^\#/, '');
				param = self.param2json(hash);
			}else{
				var smOs = self.sm;
		        for(var i = 0; i < smOs.length; i++){
		          	if(os.indexOf(smOs[i]) > 0){
		            	self.tip_bottom = 'tip_hide';
		          	}
		        }
				
				param = {
					city: amapKvStorageInit.getItem('city'),
					lnglat: amapKvStorageInit.getItem('lnglat'),
					poiid: amapKvStorageInit.getItem('poiid'),
					detail: amapKvStorageInit.getItem('detail')
				};
			}

			if(!param){
				return
			}
			
			var adcode = param.city && param.city.substr(0, 4);

			$("#subway-svg,#infowindow-content,#tip-content,.line-caption").remove();
			if(adcode != ''){
				if (!self.fileNameData[adcode]) {
					//adcode错误默认北京
					adcode = '1100';
				} else {
					adcode = adcode;
				}
			}else{
				adcode = '1100';
			}
			// 此城市有地铁
			var ua = navigator.userAgent;
			if(/Android/i.test(ua)) {
				self.loading();
				self.loadData(adcode, function(drwData) {
					self.loadingOver();
					drwSw.draw(drwData, param);
				});
			}else{
				self.loadData(adcode, function(drwData) {
					drwSw.draw(drwData, param);
				});
			}	
		},
		loadDom: function(adcode){
			var dom_key = adcode + '_dom_' + amapCache.cacheFileListObj['data/' + adcode + '_drw_' + SW.adcode + '.json'];
	        if(amapCache.enabledLocalstorage) {
	            window.localStorage.getItem(dom_key);
	        }
		},

		loadData: function(adcode, callback) {
			var self = this;
			var city_code = adcode;
			var city_name = self.fileNameData[adcode];;

			function run(){
				var requestUrl = dataServerPath + "data/" + city_code + "_drw_" + city_name + ".json";
				amapCache.loadData(requestUrl, function(data) {
					//console.log('amapCache.loadData',data);
					SW.cache.dataForDrw[data.i] = data;
					SW.cache.cities[data.i] = SW.cache.cities[data.i] || {};
					SW.cache.cities[data.i].name = data.s;
					SW.cache.cities[data.i].id = data.i;
					SW.cache.cities[data.i].offset = data.o;
					SW.cache.cities[data.i].lines = [];
					SW.cache.cities[data.i].linesNamePos = {};
					SW.cache.cities[data.i].stations = [];
					SW.cache.cities[data.i].zolines = {};
					SW.cache.cities[data.i].zostations = [];
					var _offset = data.o.split(',');
					SW.cache.offset[data.i] = SW.cache.offset[data.i] || {};
					var _x = 1000 - Number(_offset[0]);
					var _y = 1000 - Number(_offset[1]);
					SW.cache.offset[data.i].x = _x;
					SW.cache.offset[data.i].y = _y
					for (var i = 0; i < data.l.length; i++) {
						if(data.l[i].su == '1'){
							var _coords = data.l[i].c;
							for(var q = 0; q < _coords.length; q++){
								var _c = _coords[q].split(' ');
								_coords[q] = (Number(_c[0]) + _x) + ' ' + (Number(_c[1]) + _y);
							}
							data.l[i].c = _coords;
							for (var j = 0; j < data.l[i].st.length; j++) {
								var _p = data.l[i].st[j].p.split(' ');
								data.l[i].st[j].p = (Number(_p[0]) + _x) + ' ' + (Number(_p[1]) + _y);
								if(data.l[i].st[j].su == '1'){
									SW.cache.cities[data.i].stations.push(data.l[i].st[j]);
									SW.cache.stations[data.l[i].st[j].si] = data.l[i].st[j];
									SW.cache.stationspoi[data.l[i].st[j].poiid] = data.l[i].st[j];
								}
							}
							
							var _lpo = data.l[i].lp;
							if(_lpo){
								for(var s = 0; s < _lpo.length; s++){
									var _lp = _lpo[s].split(' ');
									_lpo[s] = (Number(_lp[0]) + _x) + ' ' + (Number(_lp[1]) + _y);
								}
								data.l[i].lp = _lpo;
							}
							SW.cache.cities[data.i].linesNamePos[data.l[i].ls] = data.l[i].lp;
							SW.cache.cities[data.i].lines.push(data.l[i]);
							SW.cache.lines[data.l[i].ls] = data.l[i]; //写入line
						}
					}
					
					if(callback){
						// self.toCache(data, info_data);
						callback(SW.cache.cities[city_code]);
						SW.cache.curCity.adcode = city_code;
						SW.cache.curCity.name = SW.cache.cities[city_code].name;
					}
					
				}, function () {
					
					//在上一层从本地文件读

				});

				requestUrl = dataServerPath + "data/" + city_code + "_info_" + city_name + ".json";
				amapCache.loadData(requestUrl, function(info_data) {
					for (var k = 0; k < info_data.l.length; k++) {
						for (var l = 0; l < info_data.l[k].st.length; l++) {
							SW.cache.stationsInfo[info_data.l[k].st[l].si] = info_data.l[k].st[l];
						}
					}
				});
			}

			if(!callback){
				return run();
			} else {
				if (SW.cache.cities[city_code]) {
					callback(SW.cache.cities[city_code]);
					SW.cache.curCity.adcode = city_code;
					SW.cache.curCity.name = SW.cache.cities[city_code].name;
				} else {
					run();		
				}
			}

		},
		loading: function(){
	    	$('.loading-bg').css('display','block');
	    },
	    loadingOver: function(){
	    	$('.loading-bg').css('display','none');
	    },
	    param2json: function (str) {
	    	var strArr = str.split('&');
	    	var json = {};
	    	if(strArr.length > 0){
	    		for(var i = 0; i < strArr.length; i++){
	    			var item = strArr[i].split('=');
	    			var key = item[0];
	    			var value = item[1];
	    			json[key]= value; 
	    		}
	    		return json
	    	}else{  
	    		return false
	    	}
	    }
	};

	window.cityname = SW.cityname;
	window.fileNameData = SW.fileNameData;

	return SW;

});