define("app/js/subway/main", ['app/js/subway/common'], function(SW){

    // var btn = $('<input type="button" onclick="amapKvStorage.clear();location.reload(true); return false;" value="clearKV" />')
    // btn.appendTo($(document.body));
    // btn.css({
    //     position : "fixed",
    //     right : "1em",
    //     top : "1em"
    // });

    var tip = {
        isHighlight: false,
        isInfoShow: false,
        stationsInfo: SW.cache.stationsInfo,
        stations: SW.cache.stations,
        lines: SW.cache.lines,
        station_w: 26,
        init: function() {
            this.bindEvent();
        },
        bindEvent: function() {
            var self = this;
            var font_size = 12;
            $('#subway').on('click','.line-caption',function () {
                var line_id = $(this).attr('lineid');
                $('#g-select').remove();
                $('#g-bg').css('display','block');
                drwSw.drawSelectLine(SW.cache.lines[line_id]);
            });
            $('#subway').on('click','g',function () {
                if($(this).hasClass('line_name')){
                    var line_id = $(this).attr('lineid');
                    $('#g-select').remove();
                    $('#g-bg').css('display','block');
                    drwSw.drawSelectLine(SW.cache.lines[line_id]);
                }
            });
            $('#subway').on('click','#g-bg',function () {
                $('#g-select').remove();
                $('#g-bg').css('display','none');
            });
            $('#subway').on('click','circle',function(e){
                e.stopPropagation();
                e.preventDefault();
                var obj = $(this);
                self.openInfowindow(obj);
                if($(this).closest('.g-station').find(".near-station").length > 0){
                    self.closeNearTip();
                }
            });
            $('.station-out-box').on('click','.station-out', function(e){
                e.stopPropagation();
                e.preventDefault();
                var obj = $(this);
                self.openInfowindow(obj);
                if($(this).hasClass("near-station")){
                    self.closeNearTip();
                }
            });
            $('.station-out-box').on('touchstart','.station-out', function(e){
                e.stopPropagation();
                // e.preventDefault(); 
            });
            $("#subway").on("click", ".close_info_btn", function(e){
                self.closeInfoWindow(e);
            });
            $(document).on('click',function(e){
                self.closeInfoWindow(e);
            });
            $("#subway").on('click', '#infowindow-content', function(e) {
                e.stopPropagation();
                // e.preventDefault();
            });
            $("#subway").on('touchstart', '#infowindow-content', function(e) {
                e.stopPropagation();
                // e.preventDefault();
            });
        },
        closeInfoWindow: function(e){
            var self = this;
            // e.stopPropagation;
            $("#infowindow-content").remove();
            if($("#tip-content").length > 0){
                $("#tip-content").css("display","block").addClass("open");
            }
        },
        closeNearTip: function(){
            var self = this;
            var obj = $(".tip-content");
            if(drwSw.isNearTip){
                if(obj.hasClass('open')){
                    obj.css("display","none").removeClass("open");
                }
            }
        },
        openInfowindow: function(obj){
            var self = this;
            //设置站点的id和名称及关联线路id
            var select_ref_line_id = obj.attr("line_id");
            var select_station_id = obj.attr("station_id");
            var select_station_name = obj.attr("station_name");
            //移除当前打开的infowindow
            $('#infowindow-content').remove();
            //生成infowindow
            var type = self.setInfowindowType(obj);
            self.createInfowindow(type);
            //写首发时间数据
            self.loadinfo(select_ref_line_id, select_station_id);
            //设置infowindow的位置，保证生成infowindow后获取宽高信息
            self.setInfowindowPos(type, obj);
        },
        setInfowindowType: function(object){
            var left = object.offset().left;
            var top = object.offset().top;
            var type;
            if(left < 160 || (top < 160 && left < 160) || (top < 160 && (left > 160 && left < 1680))){
                type = 'r'
            }else if(left > 1680 || (top < 160 && left > 1680)){
                type = 'l'
            }else{
                type = 't'
            }
            return type;
        },
        createInfowindow: function(type){
            var self = this;
            var subway_box = $('#subway');
            var infowin_content = $('<div class="infowindow-content" id="infowindow-content">');
            var html = '';
            subway_box.append(infowin_content);
            if(type == 't'){
                html = '<div class="info-window-top-out"><div class="info-window"><h3 id="info-title"><span id="station-name"></span><a href="javascript:void(0)" class="close_info_btn">×</a></h3><div id="info-content"><div class="info-detail-content info-content-item info-time"></div></div></div><div class="info-window-bottom ' + SW.tip_bottom + '"><div class="arrow-bg"><i class="arrow"></i></div></div></div>';
            }else if(type == 'r'){
                html = '<div class="info-window-left-out"><div class="info-window-left ' + SW.tip_bottom + '"><div class="arrow-bg"><i class="arrow"></i></div></div><div class="info-window"><h3 id="info-title"><span id="station-name"></span><a href="javascript:void(0)" class="close_info_btn">×</a></h3><div id="info-content"><div class="info-detail-content info-content-item info-time"></div></div></div></div>';
            }else if(type == 'l'){
                html = '<div class="info-window-right-out"><div class="info-window"><h3 id="info-title"><span id="station-name"></span><a href="javascript:void(0)" class="close_info_btn">×</a></h3><div id="info-content"><div class="info-detail-content info-content-item info-time"></div></div></div><div class="info-window-right ' + SW.tip_bottom + '"><div class="arrow-bg"><i class="arrow"></i></div></div></div>';
            }
            infowin_content.append(html);
        },
        setInfowindowPos: function(type, obj){
            var self = this;
            var info_win = $('.info-window'), info_content = $('#infowindow-content');
            var info_win_w = info_win.width(), info_win_h = info_win.height();
            var obj_left = obj.offset().left, obj_top = obj.offset().top;
            var infowindow_left, infowindow_top;
            if(type == 't'){
                infowindow_left = obj_left + self.station_w / 2;
                infowindow_top = obj_top;
            }else if(type == 'l'){
                infowindow_left = obj_left;
                infowindow_top = obj_top;
            }else if(type == 'r'){
                infowindow_left = obj_left;
                infowindow_top = obj_top;
            }
            info_content.css({
                top: infowindow_top + 'px',
                left: infowindow_left + 'px'
            });
        },
        
        loadinfo: function(lineId, nodeId) {        
            var self = this;
            var select_station_dpt_time = [],
                select_station_name, select_station_ref_line = [],
                infowHtml = [];
            select_station_dpt_time = self.stationsInfo[nodeId].d;
            select_station_name = self.stations[nodeId].n;
            select_station_ref_line = self.stations[nodeId].r.split("|");
            var current_station = {};
            for (var i = 0, len = select_station_dpt_time.length; i < len; i++) {
                var item = select_station_dpt_time[i];
                if (!current_station[item.ls]) {
                    current_station[item.ls] = [];
                }
                current_station[item.ls].push(item);
            }
            $("#info-title #station-name").html(select_station_name);
            var lineid = '';
            for (lineid in current_station) {
                if (current_station.hasOwnProperty(lineid)) {
                    if(self.lines[lineid]){
                        var line_sub_name = self.lines[lineid].la;
                        if(line_sub_name == ''){

                        }else{
                            line_sub_name = '(' + line_sub_name + ')';
                        }
                        infowHtml.push("<div class=\"time-item\">");
                        infowHtml.push("<h4 class=\"time-item-title\" style=\"border-bottom:1px solid #" + self.lines[lineid].cl + "\"><label class=\"line-label\" style=\"background-color:#" + self.lines[lineid].cl + ";\">地铁" + self.lines[lineid].ln + "</label><label class=\"line-sub-label\">" +  line_sub_name + "</label></h4>");
                        infowHtml.push("<ul class=\"time-item-main\">");
                        for (var j = 0; j < 2; j++) {
                            if (current_station[lineid][j]) {
                                var first_time = current_station[lineid][j].ft;
                                var last_time = current_station[lineid][j].lt;
                                // if(^([0-1]\d|2[0-3]):[0-5]\d$)
                                if(first_time.split(':')[0] != '--' && last_time.split(':')[0] != '--'){
                                    infowHtml.push("<li class=\"time-item-detail\">");
                                    infowHtml.push("<div class=\"train-direct fl\"><label class=\"direct-label\">开往</label><span class=\"direct-name\">" + self.stations[current_station[lineid][j].n].n + "</span></div>"); //下一站名，表示方向
                                    infowHtml.push("<div class=\"train-time fl\">");
                                    infowHtml.push("<div class=\"start-time time-box fl\"><label class=\"time-label\">首</label><span class\"time\">" + first_time + "</span></div>"); //首发
                                    infowHtml.push("<div class=\"last-time time-box fl\"><label class=\"time-label\">末</label><span class=\"time\">" + last_time + "</span></div>"); //末发
                                    infowHtml.push("</div>");
                                    infowHtml.push("</li>");
                                }
                            }
                        }
                        infowHtml.push("</ul>");
                        infowHtml.push("</div>");
                    }
                    
                }
            }
            $(".info-time").html(infowHtml.join(""));
        }
    };

    window.tip = tip;
    return tip;
});
